with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLMetaElement3_Interface is

   procedure Initialize (This : in out IHTMLMetaElement3_Type) is
   begin
      Set_IID (This, IID_IHTMLMetaElement3);
   end Initialize;

   function Pointer (This : IHTMLMetaElement3_Type)
     return Pointer_To_IHTMLMetaElement3
   is
   begin
      return To_Pointer_To_IHTMLMetaElement3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLMetaElement3_Type;
                     Pointer : in     Pointer_To_IHTMLMetaElement3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_url
     (This : IHTMLMetaElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_url
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_url;

   function Get_url
     (This : IHTMLMetaElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_url
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_url;

end MSHTML.IHTMLMetaElement3_Interface;

